import 'package:flutter/material.dart';

import 'components/dlg.dart';

extension StateExt<T extends StatefulWidget> on State<T> {
  void toast(String message) {
    ScaffoldMessenger.of(context).showSnackBar(
      SnackBar(
        content: Text(message),
      ),
    );
  }

  void simpleDialog(String message, [String action = 'Ok']) {
    showDialog<void>(
      context: context,
      builder: (_) {
        return SimpleDlg(message: message, action: action);
      },
    );
  }

  void dialog(List<Widget> children) {
    showDialog<void>(
      context: context,
      builder: (_) {
        return Dlg(children: children);
      },
    );
  }
}
